/**
 * 日期工具类
 */

// date格式验证
const filter = date => {
  if (date === '' || date === 0 || date === null || date === undefined) {
    return '';
  };
};

// date格式转年String
const dateReturnY = date => {
  filter(date);
  return date.getFullYear();
};

// date格式转月String
const dateReturnM = date => {
  filter(date);
  let m = date.getMonth() + 1;
  return m < 10 ? `0${m}` : m;
};

// date格式转日String
const dateReturnD = date => {
  filter(date);
  let d = date.getDate();
  return d < 10 ? `0${d}` : d;
};

// date格式转时String
const dateReturnH = date => {
  filter(date);
  let h = date.getHours();
  return h < 10 ? `0${h}` : h;
};

// date格式转分String
const dateReturnMinute = date => {
  filter(date);
  let minute = date.getMinutes();
  return minute < 10 ? `0${minute}` : minute;
};

// date格式转秒String
const dateReturnS = date => {
  filter(date);
  let s = date.getSeconds();
  return s < 10 ? `0${s}` : s;
};

// date格式转年月String
const dateReturnYM = date => {
  return `${dateReturnY(date)}-${dateReturnM(date)}`;
};

// date格式转年月日String
const dateReturnYMD = date => {
  return `${dateReturnYM(date)}-${dateReturnD(date)}`;
};

// date格式转时分String
const dateReturnHM = date => {
  return `${dateReturnH(date)}:${dateReturnMinute(date)}`;
};

// date格式转时分秒String
const dateReturnHMS = date => {
  return `${dateReturnHM(date)}:${dateReturnS(date)}`;
};

// date格式转年月日时分String
const dateReturnYMDHM = date => {
  return `${dateReturnYMD(date)} ${dateReturnHM(date)}`;
};

// date格式转年月日时分秒String
const dateReturnYMDHMS = date => {
  return `${dateReturnYMD(date)} ${dateReturnHMS(date)}`;
};

// 获取当前日期
const currentDate = () => {
  return dateReturnYMD(new Date());
};

// 获取当前时间
const currentTime = () => {
  return dateReturnHMS(new Date());
};

// 获取当前日期时间
const currentDateTime = () => {
  return dateReturnYMDHMS(new Date());
};

// 日期String转date格式
const stringToDate = date => {
  filter(date);
  date = date.replace(/-/g, '/');
  return new Date(date);
};

export default {
  dateReturnY, // date格式转年String
  dateReturnM, // date格式转月String
  dateReturnD, // date格式转日String
  dateReturnH, // date格式转时String
  dateReturnMinute, // date格式转分String
  dateReturnS, // date格式转秒String
  dateReturnYM, // date格式转年月String
  dateReturnYMD, // date格式转年月日String
  dateReturnHM, // date格式转时分String
  dateReturnHMS, // date格式转时分秒String
  dateReturnYMDHM, // date格式转年月日时分String
  dateReturnYMDHMS, // date格式转年月日时分秒String
  currentDate, // 获取当前日期
  currentTime, // 获取当前时间
  currentDateTime, // 获取当前日期时间
  stringToDate // 日期String转date格式
};
